note
	description: "A filesystem folder."
	author: "Stephan van Staden"
	date: "$Date: 2011-03-12 21:56:26 +0100 (Sa, 12 Mrz 2011) $"
	revision: "$Revision: 219 $"

class
	FS_FOLDER

inherit
	FILESYSTEM_COMPONENT

create
	make

feature

	make (a_name: STRING)
		do
			name := a_name
			create {LINKED_LIST [FILESYSTEM_COMPONENT]} entries.make
		end

	size: INTEGER
		do
			Result := 0
			from
				entries.start
			until
				entries.off
			loop
				Result := Result + entries.item.size
				entries.forth
			end
		end

	add_entry (fc: FILESYSTEM_COMPONENT)
		require
			fc.parent = Void
		do
			fc.set_parent (Current)
			entries.extend (fc)
		end

	accept (a_visitor: VISITOR)
		do
			a_visitor.visit_folder (Current)
		end

feature {VISITOR}

	entries: LIST [FILESYSTEM_COMPONENT]

end
